
// This file was generated by a tool.
// Changes to this file may cause incorrect behavior and will be lost if the file is regenerated.

"use strict";

// #####  SMART FINDER CLASS #####

var tairox = tairox || {};

tairox.smartFinder = function () {

    function open(viewId, title, options, callback) {
        var parameters = "";
        if (viewId != null) {
            if (parameters != "") parameters += "&"
            parameters += "ViewId=" + viewId;
        }
        if (title != null) {
            if (parameters != "") parameters += "&"
            parameters += "Title=" + title;
        }
        if (options != null) {
            if (parameters != "") parameters += "&"
            parameters += "Options=" + JSON.stringify(options);
        }

        var guid = sg.utls.guid();
        var url = sg.utls.url.buildUrl("XL", "SmartFinder", "Index");
        if (parameters != "") {
            url += "?" + parameters;
        }
        sg.utls.iFrameHelper.openWindow(guid, "", url, null, null, function () {
            var url = sg.utls.url.buildUrl("XL", "SmartFinder", "GetSelectedItem");
            sg.utls.ajaxPost(url, {}, function (jsonItem) {
                // jsonItem will be null if the user did not select a record (ie cancelled)
                if (jsonItem != null) {
                    var item = JSON.parse(jsonItem);
                    callback(item)
                }
            });
        });
    };

    // returns an object that exposes the public API
    return {
        open: open,
    };

}();

// ###############################

var TaiRoxXLOrderEntryCustomizationUI = TaiRoxXLOrderEntryCustomizationUI || {};
//var TaiRoxXLOrderEntryCustomizationViewModel;

var orderTypeEnum = {
    Active: 1,
    Future: 2,
    Standing: 3,
    Quote: 4
};

var valueTypeEnum = {
    Text: 1,
    Amount: 100,
    Number: 6,
    Integer: 8,
    YesNo: 9,
    Date: 3,
    Time: 4
};

TaiRoxXLOrderEntryCustomizationUI = {

    customerNumber: "",
    requiresPO: false,
    smartFinder: tairox.smartFinder,

    // Init
    init: function () {
        console.log("TaiRox Productivity Tools Extended Order Entry");

        // hide the visible controls until we know the customization's requirements are met
        $("#gridXLCustomerOptionalFields").hide();

        // we call services in the Productivity Tools web app so check that it is accessible
        TaiRoxXLOrderEntryCustomizationUI.checkPrerequisites();
    },

    checkPrerequisites: function () {
        var url = sg.utls.url.buildUrl("Customization", "TaiRoxXLOrderEntryCustomization", "IsTPTInstalled");
        $.ajax({
            type: 'get',
            dataType: 'json',
            cache: false,
            url: url,
            data: {},
            success: function (data) {
                //var jsonDataString = JSON.stringify(data.Data);
                //console.log("Data returned by IsTPTInstalled = " + jsonDataString);
                if (data.Data) {
                    TaiRoxXLOrderEntryCustomizationUI.initCustomization();
                }
                else {
                    console.log("TaiRox Productivity Tools: Is NOT Installed, or NOT Licensed");
                }
            },
            error: function (jqXHR, textStatus, error) {
            }
        });
    },

    initCustomization: function () {
        TaiRoxXLOrderEntryCustomizationUI.initIntercept();
        TaiRoxXLOrderEntryCustomizationUI.initAjaxCallIntercept();
        TaiRoxXLOrderEntryCustomizationUI.initButtons();
        TaiRoxXLOrderEntryCustomizationUI.initFinders();
        TaiRoxXLOrderEntryCustomizationUI.initTextbox();
        TaiRoxXLOrderEntryCustomizationUI.initNumericTextBox();
        TaiRoxXLOrderEntryCustomizationUI.initDropDownList();
        TaiRoxXLOrderEntryCustomizationUI.initDatePicker();
        TaiRoxXLOrderEntryCustomizationUI.initCheckBoxes();
        TaiRoxXLOrderEntryCustomizationUI.initGrid();
        TaiRoxXLOrderEntryCustomizationUI.initOtherControls();
    },

    //Hijack and intercept events, before the event
    initIntercept: function () {
        // Post button event intercept
        if ($('#btnPost')[0] == undefined) return;
        var postHandler = null;
        var postHandlers = $._data($('#btnPost')[0], 'events').click;

        if (postHandlers && postHandlers.length > 0) {
            postHandler = postHandlers[0].handler;
        }
        // unbind the original
        $('#btnPost').unbind('click');
        // bind the modified one
        $('#btnPost').click(function () {
            var orderType = $('#ddlOrderType').val();

            if ((orderType == orderTypeEnum.Quote) || !TaiRoxXLOrderEntryCustomizationUI.requiresPO) {
                postHandler();
            }
            else {
                var purchaseOrderNumber = $('#tbPONumber').val();

                if (purchaseOrderNumber == "") {
                    //TODO Translations
                    sg.utls.showMessageInfo(sg.utls.msgType.ERROR, "Purchase Order Number cannot be blank.");
                    return false;
                }
                else {
                    postHandler();
                }
            }
        });
    },

    // Intercept before/after Ajax calls
    initAjaxCallIntercept: function () {

        $(document).ajaxStart(function () {
        });

        $(document).ajaxSend(function (event, jqxhr, settings) {
        });

        // Do some processing after an ajax call succeeds
        $(document).ajaxSuccess(function (event, xhr, settings) {
            if ((settings.url.indexOf("/OE/OrderEntry/NewHeader") > -1) || (settings.url.indexOf("/OE/OrderEntry/RefreshHeader") > -1)) {
                TaiRoxXLOrderEntryCustomizationUI.customerNumber = $("#tbCustNo").val();
            }
        });

        // Do some processing after an ajax call completes
        $(document).ajaxComplete(function (event, xhr, settings) {
            // NewHeader is hooked so we clear the customer optional fields
            // RefreshHeader is hooked so we load the customer optional fields when entering the customer #
            // GetDetails is hooked so we load the customer optional fields when opening an existing order
            if ((settings.url.indexOf("/OE/OrderEntry/NewHeader") > -1) || (settings.url.indexOf("/OE/OrderEntry/RefreshHeader") > -1) || (settings.url.indexOf("/OE/OrderEntry/GetDetails") > -1)) {
                var customerNumber = $("#tbCustNo").val();
                var url = sg.utls.url.buildUrl("Customization", "TaiRoxXLOrderEntryCustomization", "GetCustomerOrderOptionalFields");

                $.ajax({
                    type: 'get',
                    dataType: 'json',
                    cache: false,
                    url: url,
                    data: { id: customerNumber },
                    success: function (data) {
                        TaiRoxXLOrderEntryCustomizationUICallback.loadCustomerOptionalFields(data);
                    },
                    error: function () {
                        console.log("Error occurred calling: " + url);
                    }
                });
            }
        });
    },

    // Init Buttons
    initButtons: function () {
    },

    // Init TextBoxs
    initTextbox: function () {
    },

    // Init Numeric TextBox
    initNumericTextBox: function () {
    },

    // Init Dropdown List
    initDropDownList: function () {
    },

    // Init Date Picker
    initDatePicker: function () {
    },

    // Init Sage 300 Finders
    initFinders: function () {
    },

    //Init CheckBoxs
    initCheckBoxes: function () {
    },

    //Init kendo Grid
    initGrid: function () {
        $("#gridXLCustomerOptionalFields").kendoGrid({
            dataSource: [],
            resizable: true,
            selectable: true,
            reorderable: true,
            editable: false,
            pageable: {
                input: true,
                numeric: false,
                refresh: false
            },
            columns: [
                {
                    field: "OptionalField",
                    title: "Optional Field",
                    attributes: { "class": "w120" },
                    headerAttributes: { "class": "w120" }
                },
                {
                    field: "OptionalFieldDescription",
                    title: "Optional Field Description",
                    attributes: { "class": "w200" },
                    headerAttributes: { "class": "w200" }
                },
                {
                    field: "TextValue",
                    title: "Value",
                    attributes: { "class": "w200" },
                    headerAttributes: { "class": "w200" }
                },
                {
                    field: "TextValueDesc",
                    title: "Value Description",
                    attributes: { "class": "w200" },
                    headerAttributes: { "class": "w200" }
                },
            ]
        });
    },

    //Init Other type controls
    initOtherControls: function () {
        // CONVERT THE LABEL FOR THE ORDER NUMBER FIELD INTO AN ANCHOR [LINK].
        var html = $('label[for="Data_OrderNumber"]').html();
        $('label[for="Data_OrderNumber"]').html('<a href="#" id="TaiRoxXLOrderEntry_OrderNumber_Link">' + html + '</a>');

        $('#TaiRoxXLOrderEntry_OrderNumber_Link').click(function () {
            if (!$('#tbOrderNo').prop('disabled')) {
                var options = {
                    ShowIncludeInactive: false,
                    ShowIncludeCompleted: true,
                    ShowIncludeOnHold: true,
                    IncludeInactive: false,
                    IncludeCompleted: false,
                    IncludeOnHold: true,
                    CustomerNumber: "",
                };
                TaiRoxXLOrderEntryCustomizationUI.smartFinder.open("OE0520", "Select Order", options, TaiRoxXLOrderEntryCustomizationUICallback.orderSmartFinderCallback);
            }
        });

        // CONVERT THE LABEL FOR THE CUSTOMER NUMBER FIELD INTO AN ANCHOR [LINK].
        var html = $('label[for="Data_CustomerNumber"]').html();
        $('label[for="Data_CustomerNumber"]').html('<a href="#" id="TaiRoxXLOrderEntry_CustomerNumber_Link">' + html + '</a>');

        $('#TaiRoxXLOrderEntry_CustomerNumber_Link').click(function () {
            if (!$('#tbCustNo').prop('disabled')) {
                //var options = {
                //    ShowIncludeInactive: false,
                //    IncludeInactive: false,
                //    CustomerNumber: "",
                //};
                TaiRoxXLOrderEntryCustomizationUI.smartFinder.open("AR0024", "Select Customer", null, TaiRoxXLOrderEntryCustomizationUICallback.customerSmartFinderCallback);
            }
        });

        // CONVERT THE LABEL FOR THE SHIP-TO LOCATION FIELD INTO AN ANCHOR [LINK].
        var html = $('label[for="Data_ShipToLocationCode"]').html();
        $('label[for="Data_ShipToLocationCode"]').html('<a href="#" id="TaiRoxXLOrderEntry_ShipToLocationCode_Link">' + html + '</a>');

        $('#TaiRoxXLOrderEntry_ShipToLocationCode_Link').click(function () {
            if (!$('#tbShipToLocCode').prop('disabled')) {
                var custno = $("#tbCustNo").val();
                var options = {
                    //ShowIncludeInactive: false,
                    //IncludeInactive: false,
                    CustomerNumber: custno,
                };
                TaiRoxXLOrderEntryCustomizationUI.smartFinder.open("AR0023", "Select Ship-To Location", options, TaiRoxXLOrderEntryCustomizationUICallback.shipToLocationSmartFinderCallback);
            }
        });
    }
};

var TaiRoxXLOrderEntryCustomizationUICallback = {

    orderSmartFinderCallback: function (item) {
        // item will be null if the user did not select a record
        if (item != null) {
            $("#tbOrderNo").val(item.OrderNumber);
            $("#tbOrderNo").change();
        }
    },

    customerSmartFinderCallback: function (item) {
        // item will be null if the user did not select a record
        if (item != null) {
            $("#tbCustNo").val(item.CustomerNumber);
            $("#tbCustNo").change();
        }
    },

    shipToLocationSmartFinderCallback: function (item) {
        // item will be null if the user did not select a record
        if (item != null) {
            $("#tbShipToLocCode").val(item.ShipToLocation);
            $("#tbShipToLocCode").change();
        }
    },

    loadCustomerOptionalFields: function (data) {
        var fields = [];

        console.log(JSON.stringify(data));

        if (data.Data.DisplayCustomerOptionalFields) {
            for (var i = 0; i < data.Data.OptionalFields.length; i++) {
                fields.push({
                    OptionalField: data.Data.OptionalFields[i].OptionalField,
                    OptionalFieldDescription: data.Data.OptionalFields[i].OptionalFieldDescription,
                    TextValue: TaiRoxXLOrderEntryCustomizationUICallback.formatValue(data.Data.OptionalFields[i]),
                    TextValueDesc: data.Data.OptionalFields[i].ValueDescription
                });
            }

            var grid = $("#gridXLCustomerOptionalFields").data("kendoGrid");
            var gridDataSource = new kendo.data.DataSource({ data: fields, page: 1, pageSize: sg.utls.gridPageSize });

            grid.setDataSource(gridDataSource);
            gridDataSource.read();

            $("#gridXLCustomerOptionalFields").show();
        } else {
            $("#gridXLCustomerOptionalFields").hide();
        }

        TaiRoxXLOrderEntryCustomizationUI.requiresPO = data.Data.RequiresPurchaseOrder;
    },

    formatValue: function(data) {
        var type = data.Type,
            value = data.Value,
            decimals = data.Decimals;

        if (value === null || data.SWSET === 0) {
            return "";
        } else if (type === valueTypeEnum.YesNo) {
            // TODO Need transalations.
            return value.trim() === "1" ? "Yes" : "No";
        } else if (type === valueTypeEnum.Date) {
            return value === "00000000" ? "" : sg.utls.kndoUI.getFormattedDate(value);
        } else if (type === valueTypeEnum.Time && value.indexOf(':') < 0) {
            return value.substring(0, 2) + ":" + value.substring(2, 4) + ":" + value.substring(4, 6);
        } else if (type === valueTypeEnum.Integer || type === valueTypeEnum.Amount || type === valueTypeEnum.Number) {
            return sg.utls.kndoUI.getFormattedDecimalNumber(value || 0, decimals);
        } else {
            return sg.utls.htmlEncode(value);
        }
    }
};

// Initial Entry
$(function () {
    TaiRoxXLOrderEntryCustomizationUI.init();
});