
// This file was generated by a tool. 
// Changes to this file may cause incorrect behavior and will be lost if the file is regenerated. 

"use strict";

// #####  SMART FINDER CLASS #####

var tairox = tairox || {};

tairox.smartFinder = function () {

    function open(viewId, title, options, callback) {
        var parameters = "";
        if (viewId != null) {
            if (parameters != "") parameters += "&"
            parameters += "ViewId=" + viewId;
        }
        if (title != null) {
            if (parameters != "") parameters += "&"
            parameters += "Title=" + title;
        }
        if (options != null) {
            if (parameters != "") parameters += "&"
            parameters += "Options=" + JSON.stringify(options);
        }

        var guid = sg.utls.guid();
        var url = sg.utls.url.buildUrl("XL", "SmartFinder", "Index");
        if (parameters != "") {
            url += "?" + parameters;
        }
        sg.utls.iFrameHelper.openWindow(guid, "", url, null, null, function () {
            var url = sg.utls.url.buildUrl("XL", "SmartFinder", "GetSelectedItem");
            sg.utls.ajaxPost(url, {}, function (jsonItem) {
                // jsonItem will be null if the user did not select a record (ie cancelled)
                if (jsonItem != null) {
                    var item = JSON.parse(jsonItem);
                    callback(item)
                }
            });
        });
    };

    // returns an object that exposes the public API
    return {
        open: open,
    };

}();

// ###############################

var TaiRoxXLShipmentEntryCustomizationUI = TaiRoxXLShipmentEntryCustomizationUI || {};
//var TaiRoxXLShipmentEntryCustomizationViewModel;

var valueTypeEnum = {
    Text: 1,
    Amount: 100,
    Number: 6,
    Integer: 8,
    YesNo: 9,
    Date: 3,
    Time: 4
};

TaiRoxXLShipmentEntryCustomizationUI = {

    customerNumber: "",
    requiresPO: false,
    smartFinder: tairox.smartFinder,

    // Init
    init: function () {
        console.log("TaiRox Productivity Tools Extended Shipment Entry");

        // hide the visible controls until we know the customization's requirements are met
        $("#gridXLCustomerOptionalFields").hide();

        // we call services in the Productivity Tools web app so check that it is accessible
        TaiRoxXLShipmentEntryCustomizationUI.checkPrerequisites();
    },

    checkPrerequisites: function () {
        var url = sg.utls.url.buildUrl("Customization", "TaiRoxXLShipmentEntryCustomization", "IsTPTInstalled");
        $.ajax({
            type: 'get',
            dataType: 'json',
            cache: false,
            url: url,
            data: {},
            success: function (data) {
                //var jsonDataString = JSON.stringify(data.Data);
                //console.log("Data returned by IsTPTInstalled = " + jsonDataString);
                if (data.Data) {
                    TaiRoxXLShipmentEntryCustomizationUI.initCustomization();
                }
                else {
                    console.log("TaiRox Productivity Tools: Is NOT Installed, or NOT Licensed");
                }
            },
            error: function (jqXHR, textStatus, error) {
            }
        });
    },

    initCustomization: function () {
        TaiRoxXLShipmentEntryCustomizationUI.initIntercept();
        TaiRoxXLShipmentEntryCustomizationUI.initAjaxCallIntercept();
        TaiRoxXLShipmentEntryCustomizationUI.initButtons();
        TaiRoxXLShipmentEntryCustomizationUI.initFinders();
        TaiRoxXLShipmentEntryCustomizationUI.initTextbox();
        TaiRoxXLShipmentEntryCustomizationUI.initNumericTextBox();
        TaiRoxXLShipmentEntryCustomizationUI.initDropDownList();
        TaiRoxXLShipmentEntryCustomizationUI.initDatePicker();
        TaiRoxXLShipmentEntryCustomizationUI.initCheckBoxes();
        TaiRoxXLShipmentEntryCustomizationUI.initGrid();
        TaiRoxXLShipmentEntryCustomizationUI.initOtherControls();
    },

    // Hijack and intercept events, before the event
    initIntercept: function () {
        // Post button event intercept
        if ($('#btnShipmentEntryPost')[0] == undefined) return;
        var postHandler = null;
        var postHandlers = $._data($('#btnShipmentEntryPost')[0], 'events').click;

        if (postHandlers && postHandlers.length > 0) {
            postHandler = postHandlers[0].handler;
        }
        // unbind the original
        $('#btnShipmentEntryPost').unbind('click');
        // bind the modified one
        $('#btnShipmentEntryPost').click(function () {
            var orderNumber = $('#txtOrderNumber').val();

            if ((orderNumber != "") || !TaiRoxXLShipmentEntryCustomizationUI.requiresPO) {
                postHandler();
            }
            else {
                var purchaseOrderNumber = $('#txtPurchaseOrderNumber').val();

                if (purchaseOrderNumber == "") {
                    //TODO Translations
                    sg.utls.showMessageInfo(sg.utls.msgType.ERROR, "Purchase Order Number cannot be blank.");
                    return false;
                }
                else {
                    postHandler();
                }
            }
        });
    },

    // Intercept before/after Ajax calls
    initAjaxCallIntercept: function () {

        $(document).ajaxStart(function () {
        });

        $(document).ajaxSend(function (event, jqxhr, settings) {
        });

        // Do some processing after an ajax call succeeds
        $(document).ajaxSuccess(function (event, xhr, settings) {
            if ((settings.url.indexOf("/OE/ShipmentEntry/GetById") > -1) || (settings.url.indexOf("/OE/ShipmentEntry/RefreshHeader") > -1)) {
                TaiRoxXLShipmentEntryCustomizationUI.customerNumber = $("#txtCustomerNumber").val();
            }
        });

        // Do some processing after an ajax call completes
        $(document).ajaxComplete(function (event, xhr, settings) {
            // GetById is hooked so we get the customer optional fields when the shipment # is changed
            // RefreshHeader is hooked so we load the customer optional fields when entering the customer #
            if ((settings.url.indexOf("/OE/ShipmentEntry/GetById") > -1) || (settings.url.indexOf("/OE/ShipmentEntry/RefreshHeader") > -1)) {
                var customerNumber = $("#txtCustomerNumber").val();
                var url = sg.utls.url.buildUrl("Customization", "TaiRoxXLShipmentEntryCustomization", "GetCustomerOrderOptionalFields");

                $.ajax({
                    type: 'get',
                    dataType: 'json',
                    cache: false,
                    url: url,
                    data: { id: customerNumber },
                    success: function (data) {
                        TaiRoxXLShipmentEntryCustomizationUICallback.loadCustomerOptionalFields(data);
                    },
                    error: function () {
                        console.log("Error occurred calling: " + url);
                    }
                });
            }
        });
    },

    // Init Buttons
    initButtons: function () {
    },

    // Init TextBoxs
    initTextbox: function () {
    },

    // Init Numeric TextBox
    initNumericTextBox: function () {
    },

    // Init Dropdown List
    initDropDownList: function () {
    },

    // Init Date Picker
    initDatePicker: function () {
    },

    // Init Sage 300 Finders
    initFinders: function () {
    },

    //Init CheckBoxs
    initCheckBoxes: function () {
    },

    //Init kendo Grid
    initGrid: function () {
        $("#gridXLCustomerOptionalFields").kendoGrid({
            dataSource: [],
            resizable: true,
            selectable: true,
            reorderable: true,
            editable: false,
            pageable: {
                input: true,
                numeric: false,
                refresh: false
            },
            columns: [
                {
                    field: "OptionalField",
                    title: "Optional Field",
                    attributes: { "class": "w120" },
                    headerAttributes: { "class": "w120" }
                },
                {
                    field: "OptionalFieldDescription",
                    title: "Optional Field Description",
                    attributes: { "class": "w200" },
                    headerAttributes: { "class": "w200" }
                },
                {
                    field: "TextValue",
                    title: "Value",
                    attributes: { "class": "w200" },
                    headerAttributes: { "class": "w200" }
                },
                {
                    field: "TextValueDesc",
                    title: "Value Description",
                    attributes: { "class": "w200" },
                    headerAttributes: { "class": "w200" }
                },
            ]
        });
    },

    //Init Other type controls
    initOtherControls: function () {
        // CONVERT THE LABEL FOR THE ORDER NUMBER FIELD INTO AN ANCHOR [LINK].
        var html = $('label[for="Data_OrderNumber"]').html();
        $('label[for="Data_OrderNumber"]').html('<a href="#" id="TaiRoxXLShipmentEntry_OrderNumber_Link">' + html + '</a>');

        $('#TaiRoxXLShipmentEntry_OrderNumber_Link').click(function () {
            if (!$('#txtOrderNo').prop('disabled')) {
                var options = {
                    ShowIncludeOnHold: true,
                    IncludeCompleted: false,
                    IncludeOnHold: false,
                    CustomerNumber: $('#txtCustomerNumber').val(),  // filter by customer if one has been entered
                    OrderType: 1,  // Active orders only
                };
                TaiRoxXLShipmentEntryCustomizationUI.smartFinder.open("OE0520", "Select Order", options, TaiRoxXLShipmentEntryCustomizationUICallback.orderSmartFinderCallback);
            }
        });

        // CONVERT THE LABEL FOR THE CUSTOMER NUMBER FIELD INTO AN ANCHOR [LINK].
        var html = $('label[for="Data_CustomerNumber"]').html();
        $('label[for="Data_CustomerNumber"]').html('<a href="#" id="TaiRoxXLShipmentEntry_CustomerNumber_Link">' + html + '</a>');

        $('#TaiRoxXLShipmentEntry_CustomerNumber_Link').click(function () {
            if (!$('#txtCustomerNumber').prop('disabled')) {
                //var options = {
                //    ShowIncludeInactive: false,
                //    IncludeInactive: false,
                //    CustomerNumber: "",
                //};
                TaiRoxXLShipmentEntryCustomizationUI.smartFinder.open("AR0024", "Select Customer", null, TaiRoxXLShipmentEntryCustomizationUICallback.customerSmartFinderCallback);
            }
        });

        // CONVERT THE LABEL FOR THE SHIP-TO LOCATION FIELD INTO AN ANCHOR [LINK].
        var html = $('label[for="Data_ShipToLocationCode"]').html();
        $('label[for="Data_ShipToLocationCode"]').html('<a href="#" id="TaiRoxXLShipmentEntry_ShipToLocationCode_Link">' + html + '</a>');

        $('#TaiRoxXLShipmentEntry_ShipToLocationCode_Link').click(function () {
            if (!$('#txtShipToLocation').prop('disabled')) {
                var custno = $("#txtCustomerNumber").val();
                var options = {
                    //ShowIncludeInactive: false,
                    //IncludeInactive: false,
                    CustomerNumber: custno,
                };
                TaiRoxXLShipmentEntryCustomizationUI.smartFinder.open("AR0023", "Select Ship-To Location", options, TaiRoxXLShipmentEntryCustomizationUICallback.shipToLocationSmartFinderCallback);
            }
        });
    },
};

var TaiRoxXLShipmentEntryCustomizationUICallback = {

    orderSmartFinderCallback: function (item) {
        // item will be null if the user did not select a record
        if (item != null) {
            $("#txtOrderNumber").val(item.OrderNumber);
            $("#txtOrderNumber").change();
        }
    },

    customerSmartFinderCallback: function (item) {
        // item will be null if the user did not select a record
        if (item != null) {
            $("#txtCustomerNumber").val(item.CustomerNumber);
            $("#txtCustomerNumber").change();
        }
    },

    shipToLocationSmartFinderCallback: function (item) {
        // item will be null if the user did not select a record
        if (item != null) {
            $("#txtShipToLocation").val(item.ShipToLocation);
            $("#txtShipToLocation").change();
        }
    },

    loadCustomerOptionalFields: function (data) {
        var fields = [];

        console.log(JSON.stringify(data));

        if (data.Data.DisplayCustomerOptionalFields) {
            for (var i = 0; i < data.Data.OptionalFields.length; i++) {
                fields.push({
                    OptionalField: data.Data.OptionalFields[i].OptionalField,
                    OptionalFieldDescription: data.Data.OptionalFields[i].OptionalFieldDescription,
                    TextValue: TaiRoxXLShipmentEntryCustomizationUICallback.formatValue(data.Data.OptionalFields[i]),
                    TextValueDesc: data.Data.OptionalFields[i].ValueDescription
                });
            }

            var grid = $("#gridXLCustomerOptionalFields").data("kendoGrid");
            var gridDataSource = new kendo.data.DataSource({ data: fields, page: 1, pageSize: sg.utls.gridPageSize });

            grid.setDataSource(gridDataSource);
            gridDataSource.read();

            $("#gridXLCustomerOptionalFields").show();
        } else {
            $("#gridXLCustomerOptionalFields").hide();
        }

        TaiRoxXLShipmentEntryCustomizationUI.requiresPO = data.Data.RequiresPurchaseOrder;
    },

    formatValue: function (data) {
        var type = data.Type,
            value = data.Value,
            decimals = data.Decimals;

        if (value === null || data.SWSET === 0) {
            return "";
        } else if (type === valueTypeEnum.YesNo) {
            // TODO Need transalations.
            return value.trim() === "1" ? "Yes" : "No";
        } else if (type === valueTypeEnum.Date) {
            return value === "00000000" ? "" : sg.utls.kndoUI.getFormattedDate(value);
        } else if (type === valueTypeEnum.Time && value.indexOf(':') < 0) {
            return value.substring(0, 2) + ":" + value.substring(2, 4) + ":" + value.substring(4, 6);
        } else if (type === valueTypeEnum.Integer || type === valueTypeEnum.Amount || type === valueTypeEnum.Number) {
            return sg.utls.kndoUI.getFormattedDecimalNumber(value || 0, decimals);
        } else {
            return sg.utls.htmlEncode(value);
        }
    }
};

// Initial Entry
$(function () {
    TaiRoxXLShipmentEntryCustomizationUI.init();
});